import { BacktraceClientOptions } from '..';
/**
 * Handles Backtrace Metrics.
 */
export declare class BacktraceMetrics {
    private readonly attributeProvider;
    private readonly _logger;
    private readonly universe;
    private readonly token;
    private readonly hostname;
    private summedEndpoint;
    private uniqueEndpoint;
    private sessionId;
    constructor(configuration: BacktraceClientOptions, attributeProvider: () => object, _logger: {
        error(...data: any[]): void;
    } | undefined);
    /**
     * Handle persisting of session. When called, will create a new session.
     */
    private handleSession;
    /**
     * Send POST to unique-events API endpoint
     */
    sendUniqueEvent(): Promise<void>;
    /**
     * Send POST to summed-events API endpoint
     */
    sendSummedEvent(metricGroup: string): Promise<void>;
    private getEventAttributes;
}
