"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IdentityManager = void 0;
var axios_1 = __importDefault(require("axios"));
var crypto_1 = require("crypto");
var https_1 = __importDefault(require("https"));
var apiError_1 = require("../model/apiError");
var ProjectValidation = __importStar(require("../service/projectValidation"));
var backtraceUniverseHelper_1 = require("../universe/backtraceUniverseHelper");
/**
 * Identity manager
 */
var IdentityManager = /** @class */ (function () {
    function IdentityManager(descr, logger) {
        this.descr = descr;
        /*
         * Stores opaque objects per authenticated remote coronerd.
         * Available for consumers to use as they see fit.
         */
        this.authenticated = {};
        /*
         * Stores coronerd values at the register step,
         * to be attached during authRequest step.
         * Uses universe names as key.
         */
        this.registeredUniverses = {};
        this.httpsAgent = this.descr.isOnPremise
            ? new https_1.default.Agent({ rejectUnauthorized: false })
            : https_1.default.globalAgent;
        if (logger) {
            this.setLogger(logger);
        }
    }
    /**
     * Sets the coroned callback function - the funciton that will be
     * executed by the identity manager, when a new coronerd instance
     * registers. Setting a new coronerd callback will also invoke the
     * callback funciton with all saved unique ip addresses.
     * @param callback: callback function that retrieves a registered coronerd ip address
     */
    IdentityManager.prototype.coronerdCallback = function (callback) {
        var _this = this;
        this.onCoronerCallback = callback;
        var authenticatedIpAddresses = Object.keys(this.authenticated);
        authenticatedIpAddresses.forEach(function (ip) { return __awaiter(_this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: 
                    /**
                     * Pass false as a alreadyRegisteredFlag to tell
                     * the callback function, this is a new coroned address for
                     * the callback consumer.
                     */
                    return [4 /*yield*/, callback(ip, false)];
                    case 1:
                        /**
                         * Pass false as a alreadyRegisteredFlag to tell
                         * the callback function, this is a new coroned address for
                         * the callback consumer.
                         */
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        }); });
    };
    IdentityManager.prototype.setLogger = function (logger) {
        if (!logger || !logger.log) {
            throw new TypeError('unusable logger passed in');
        }
        this.logger = logger;
    };
    /*
     * Generate a middleware handler for Express.js, using options to hook the
     * service up.
     *
     * @param opts ICoronerRequestOption - coronerd url callback if desired
     */
    IdentityManager.prototype.serviceRequest = function (opts) {
        var _this = this;
        if (opts === null || opts === void 0 ? void 0 : opts.coronerdCallback) {
            this.onCoronerCallback = opts.coronerdCallback;
        }
        /*
         * Handle <prefix>/service requests.  These require action QS.  Other QS
         * are defined per action.
         */
        return [
            function (request, response, next) { return __awaiter(_this, void 0, void 0, function () {
                var action, _a, _b, url, nonce, hmac, service_to_coronerd_url, alreadyRegistered;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0:
                            if (!request.body) {
                                return [2 /*return*/, next(new apiError_1.ApiError('Missing body', 400))];
                            }
                            action = request.body.action;
                            if (!action) {
                                return [2 /*return*/, next(new apiError_1.ApiError('Missing action parameter', 400))];
                            }
                            _a = action;
                            switch (_a) {
                                case 'register': return [3 /*break*/, 1];
                            }
                            return [3 /*break*/, 4];
                        case 1:
                            _b = request.body, url = _b.url, nonce = _b.nonce, hmac = _b.hmac, service_to_coronerd_url = _b.service_to_coronerd_url;
                            if (!url || !nonce || !hmac) {
                                return [2 /*return*/, next(new apiError_1.ApiError("missing parameters\n                  ".concat(!url ? 'url' : '', "\n                  ").concat(!nonce ? 'nonce' : '', "\n                  ").concat(!hmac ? 'hmac' : ''), 400))];
                            }
                            if (!this.checkHmac(this.descr.secret, nonce, hmac)) {
                                return [2 /*return*/, next(new apiError_1.ApiError('Unauthorized', 403))];
                            }
                            alreadyRegistered = !!this.authenticated[url];
                            if (!alreadyRegistered) {
                                this.authenticated[url] = {};
                            }
                            /*
                             * Track registered coronerds information so that it
                             *  can be passed to consumer through authenticateRequest's
                             *  coronerAuth object. This asynchronously updates
                             *  local store with coronerdData for each universe
                             *  discovered in a connected coronerd.
                             */
                            this.retrieveAndStoreCoronerdInfo(url, service_to_coronerd_url);
                            if (!this.onCoronerCallback) return [3 /*break*/, 3];
                            return [4 /*yield*/, this.onCoronerCallback(url, alreadyRegistered)];
                        case 2:
                            _c.sent();
                            _c.label = 3;
                        case 3:
                            // Ignore project validation in service layer handshake.
                            ProjectValidation.setValid(response);
                            response.json({
                                status: 'ok',
                            });
                            return [3 /*break*/, 5];
                        case 4: throw new apiError_1.ApiError('invalid action', 400);
                        case 5: return [2 /*return*/];
                    }
                });
            }); },
        ];
    };
    /**
     * Generate a middleware for Express.js which validates a request
     * by comparing universe/project data avaialble in the request object
     * with universe/project data available in the Authenticated request.
     *
     * This middleware must be used after the authenticateRequest.
     * @param dataProvider universe/project provider.
     */
    IdentityManager.prototype.validateProjectAccess = function (dataProvider) {
        var _this = this;
        return function (req, res, next) {
            var authRequest = req;
            if (!authRequest.coronerAuth || !authRequest.coronerAuth.cfg) {
                return next(new apiError_1.ApiError('Cannot verify the user access to specific project/universe.', 500));
            }
            var _a = dataProvider(authRequest), universe = _a.universe, project = _a.project;
            if (!(universe in authRequest.coronerAuth.cfg.universes)) {
                return next(new apiError_1.ApiError('Unauthorized.', 401));
            }
            if (project && !_this.checkProjectAccess(req, res, [project])) {
                return next(new apiError_1.ApiError('Unauthorized.', 401));
            }
            _this.bypassProjectAccessCheck(res);
            next();
        };
    };
    /**
     * Generate a middleware for Express.js, which authenticates a request given
     * its URL and session token, provided by an earlier callback in
     * req.coronerAuth.
     * Upon success, the configuration data will be in req.coronerAuth.cfg.
     */
    IdentityManager.prototype.authenticateRequest = function () {
        var _this = this;
        return function (request, _, next) { return __awaiter(_this, void 0, void 0, function () {
            var _a, url, token, authRequest, serverConfiguration, requestedUniverse, registeredUniverse, err_1;
            var _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = this.readCoronerAuthInfo(request), url = _a.url, token = _a.token;
                        if (!token || !url) {
                            return [2 /*return*/, next(new apiError_1.ApiError("".concat(request.ip, ": Missing internal params = token or url"), 403))];
                        }
                        authRequest = request;
                        if (!authRequest) {
                            return [2 /*return*/, next(new apiError_1.ApiError("Invalid request cast", 500))];
                        }
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 5, , 6]);
                        return [4 /*yield*/, this.authenticate(url, token)];
                    case 2:
                        serverConfiguration = _c.sent();
                        if (!serverConfiguration || !serverConfiguration.user) {
                            return [2 /*return*/, next(new apiError_1.ApiError('Auth failure', 403))];
                        }
                        requestedUniverse = serverConfiguration.universe.name;
                        registeredUniverse = this.registeredUniverses[requestedUniverse];
                        if (!!registeredUniverse) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.retrieveAndStoreCoronerdInfo(url)];
                    case 3:
                        _c.sent();
                        registeredUniverse = this.registeredUniverses[requestedUniverse];
                        _c.label = 4;
                    case 4:
                        if (!registeredUniverse) {
                            this.log('warn', "universe ".concat(requestedUniverse, " not found in registeredUniverses"));
                        }
                        authRequest.coronerAuth = {
                            url: url,
                            token: token,
                            cfg: serverConfiguration,
                            service_to_coronerd_url: registeredUniverse === null || registeredUniverse === void 0 ? void 0 : registeredUniverse.serviceToCoronerdUrl,
                        };
                        next();
                        return [3 /*break*/, 6];
                    case 5:
                        err_1 = _c.sent();
                        if (axios_1.default.isAxiosError(err_1) && ((_b = err_1.response) === null || _b === void 0 ? void 0 : _b.status)) {
                            next(new apiError_1.ApiError(err_1.message, err_1.response.status));
                        }
                        else {
                            next(err_1);
                        }
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        }); };
    };
    /**
     * This assumes route has already passed authentication through authenticateRequest
     * and uses /api/config result from that to check projects.
     */
    IdentityManager.prototype.checkProjectAccess = function (request, response, projects) {
        var _a, _b, _c, _d, _e;
        var authRequest = request;
        var universe = (_b = (_a = authRequest === null || authRequest === void 0 ? void 0 : authRequest.coronerAuth) === null || _a === void 0 ? void 0 : _a.cfg) === null || _b === void 0 ? void 0 : _b.universe;
        var projectsExt = universe &&
            ((_e = (_d = (_c = authRequest === null || authRequest === void 0 ? void 0 : authRequest.coronerAuth) === null || _c === void 0 ? void 0 : _c.cfg) === null || _d === void 0 ? void 0 : _d.universes[universe.name]) === null || _e === void 0 ? void 0 : _e.projects_ext);
        if (!projectsExt) {
            this.log('debug', "missing projects_ext");
            return false; // invalidated because flag is never set to true
        }
        return ProjectValidation.check(response, projectsExt, projects);
    };
    /**
     * Unconditionally set projectValidated flag to true.
     * Allows service routes that do not need project validation to procceed with
     * typical Express send method.
     */
    IdentityManager.prototype.bypassProjectAccessCheck = function (response) {
        ProjectValidation.setValid(response);
    };
    /**
     * Use coronerd auth method to validate url and session token provided by user
     * For Express apps, consider using the authenticateRequest middleware instead
     * @param url coronerd url
     * @param token coronerd token
     */
    IdentityManager.prototype.authenticate = function (url, token) {
        return __awaiter(this, void 0, void 0, function () {
            var prefix, result, coronerd_nonce, coronerd_hmac;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!token || !url) {
                            throw new apiError_1.ApiError('missing url/token', 400);
                        }
                        prefix = url.endsWith('/') ? '' : '/';
                        return [4 /*yield*/, axios_1.default.get("".concat(url).concat(prefix, "api/config"), {
                                httpsAgent: this.httpsAgent,
                                headers: {
                                    'X-Service-Name': this.descr.name,
                                    'X-Coroner-Token': this.sanitizeHeader(token),
                                    'X-Service-HMAC': this.generateHmac(this.descr.secret, token),
                                },
                            })];
                    case 1:
                        result = _a.sent();
                        if (result.status !== 200) {
                            throw new apiError_1.ApiError("Invalid server response code ".concat(result.status), result.status);
                        }
                        coronerd_nonce = result.headers['x-service-nonce'];
                        coronerd_hmac = result.headers['x-service-hmac'];
                        if (!coronerd_nonce || !coronerd_hmac) {
                            throw new apiError_1.ApiError('Missing response parameters - coronerd_nonce/hmac', 400);
                        }
                        if (!this.checkHmac(this.descr.secret, coronerd_nonce, coronerd_hmac)) {
                            throw new apiError_1.ApiError('Invalid server generated HMAC', 400);
                        }
                        return [2 /*return*/, result.data];
                }
            });
        });
    };
    /**
     * Login to a coronerd.
     * @param Coronerd base URL to login to
     */
    IdentityManager.prototype.loginCoronerd = function (coronerdUrl) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var prefix, protocol, requestUrl, nonce, hmac, result, err_2;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!coronerdUrl) {
                            throw new Error('CoronerdUrl is undefined or empty string');
                        }
                        prefix = coronerdUrl.endsWith('/') ? '' : '/';
                        protocol = coronerdUrl.startsWith('http') ? '' : backtraceUniverseHelper_1.http;
                        requestUrl = "".concat(protocol).concat(coronerdUrl).concat(prefix, "api/login");
                        nonce = (0, crypto_1.randomBytes)(32).toString('hex');
                        hmac = this.generateHmac(this.descr.secret, nonce);
                        _b.label = 1;
                    case 1:
                        _b.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.post(requestUrl, null, {
                                httpsAgent: this.httpsAgent,
                                headers: {
                                    'X-Service-Name': this.descr.name,
                                    'X-Service-Nonce': nonce,
                                    'X-Service-HMAC': hmac,
                                },
                            })];
                    case 2:
                        result = _b.sent();
                        return [2 /*return*/, result.status === 200 ? result.data : undefined];
                    case 3:
                        err_2 = _b.sent();
                        (_a = this.logger) === null || _a === void 0 ? void 0 : _a.error(err_2, "Cannot login to coronerd. Requested address: ".concat(requestUrl));
                        return [2 /*return*/, undefined];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * Retrieves the zeroconf from a coronerd
     * to store data for later client consumption.
     */
    IdentityManager.prototype.retrieveAndStoreCoronerdInfo = function (coronerdUrl, serviceToCoronerdUrl) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var bpgRequestUrl, prefix, protocol, bpgUniverseRequestUrl, serviceConfiguration, token, headers, bpgUniverseResult, bpgUniverseObjects, err_3;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!coronerdUrl) {
                            throw new Error('CoronerdUrl is undefined or empty string');
                        }
                        bpgRequestUrl = serviceToCoronerdUrl !== null && serviceToCoronerdUrl !== void 0 ? serviceToCoronerdUrl : coronerdUrl;
                        prefix = bpgRequestUrl.endsWith('/') ? '' : '/';
                        protocol = bpgRequestUrl.startsWith('http') ? '' : backtraceUniverseHelper_1.http;
                        bpgUniverseRequestUrl = "".concat(protocol).concat(bpgRequestUrl).concat(prefix, "api/bpg");
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 4, , 5]);
                        return [4 /*yield*/, this.loginCoronerd(bpgRequestUrl)];
                    case 2:
                        serviceConfiguration = _d.sent();
                        if (!serviceConfiguration) {
                            (_a = this.logger) === null || _a === void 0 ? void 0 : _a.warn("Cannot login to coronerd instance from the service. Coroenrd URL :".concat(bpgRequestUrl));
                            return [2 /*return*/, false];
                        }
                        token = serviceConfiguration.token;
                        headers = {
                            'X-Coroner-Location': coronerdUrl,
                            'Content-Type': 'application/json',
                        };
                        if (token) {
                            headers['X-Coroner-Token'] = token;
                        }
                        else {
                            (_b = this.logger) === null || _b === void 0 ? void 0 : _b.warn('BPG call: Coronerd token is undefined.');
                        }
                        return [4 /*yield*/, axios_1.default.post(bpgUniverseRequestUrl, {
                                actions: [{ action: 'get', type: 'configuration/universe' }],
                            }, {
                                httpsAgent: this.httpsAgent,
                                headers: headers,
                            })];
                    case 3:
                        bpgUniverseResult = _d.sent();
                        bpgUniverseObjects = bpgUniverseResult.data.results[0].result;
                        bpgUniverseObjects.forEach(function (universe) {
                            if (universe.deleted !== 1) {
                                _this.registeredUniverses[universe.name] = {
                                    serviceToCoronerdUrl: serviceToCoronerdUrl !== null && serviceToCoronerdUrl !== void 0 ? serviceToCoronerdUrl : coronerdUrl,
                                };
                            }
                        });
                        return [2 /*return*/, true];
                    case 4:
                        err_3 = _d.sent();
                        (_c = this.logger) === null || _c === void 0 ? void 0 : _c.error(err_3, "Cannot get universes from coronerd. Requested address: ".concat(bpgUniverseRequestUrl));
                        return [2 /*return*/, false];
                    case 5: return [2 /*return*/];
                }
            });
        });
    };
    /**
     * @deprecated: these methods will be removed in new backtrace-service  update
     * Check if authtoken is a valid token generated by coronerd
     * @param universeUrl url to coronerd universe
     * @param authToken user token
     */
    IdentityManager.prototype.isValidToken = function (universeUrl, authToken) {
        return __awaiter(this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getConfiguration(universeUrl, authToken)];
                    case 1:
                        result = _a.sent();
                        return [2 /*return*/, result !== undefined];
                }
            });
        });
    };
    /**
     * @deprecated: these methods will be removed in new backtrace-service  update
     * Get Backtrace configuration
     * @param universeUrl url to coronerd universe
     * @param authToken user token
     */
    IdentityManager.prototype.getConfiguration = function (universeUrl, authToken) {
        return __awaiter(this, void 0, void 0, function () {
            var prefix, protocol, requestUrl, result, err_4;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!authToken || !universeUrl) {
                            return [2 /*return*/, undefined];
                        }
                        prefix = universeUrl.endsWith('/') ? '' : '/';
                        protocol = universeUrl.startsWith('http') ? '' : backtraceUniverseHelper_1.http;
                        requestUrl = "".concat(protocol).concat(universeUrl).concat(prefix, "api/config");
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, axios_1.default.get(requestUrl, {
                                headers: {
                                    'X-Coroner-Token': authToken,
                                },
                            })];
                    case 2:
                        result = _a.sent();
                        return [2 /*return*/, result.status === 200 ? result.data : undefined];
                    case 3:
                        err_4 = _a.sent();
                        return [2 /*return*/, undefined];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    IdentityManager.prototype.generateHmac = function (secret, nonce) {
        if (!secret || !nonce) {
            return '';
        }
        return (0, crypto_1.createHmac)('sha256', secret).update(nonce).digest('hex');
    };
    IdentityManager.prototype.checkHmac = function (secret, nonce, proposedHMac) {
        var hmac = this.generateHmac(secret, nonce);
        if (!hmac) {
            return false;
        }
        return hmac === proposedHMac;
    };
    IdentityManager.prototype.sanitizeHeader = function (value) {
        if (!value) {
            return '';
        }
        return value.replace(/[^a-z0-9A-Z?!]/gi, '');
    };
    IdentityManager.prototype.log = function (level, msg) {
        if (this.logger) {
            this.logger.log(level, msg);
        }
    };
    IdentityManager.prototype.readCoronerAuthInfo = function (request) {
        var authRequest = request;
        var data = authRequest.coronerAuth;
        if (!data) {
            data = {
                token: this.sanitizeHeader(request.get('X-Coroner-Token')),
                url: request.get('X-Coroner-Location') ||
                    request.get('origin'),
            };
            if (data.url && !data.url.startsWith('http')) {
                data.url = "".concat(backtraceUniverseHelper_1.http).concat(data.url);
            }
        }
        return data;
    };
    return IdentityManager;
}());
exports.IdentityManager = IdentityManager;
// vim:set ts=2 sw=2 et:
//# sourceMappingURL=identity.js.map