import express from 'express';
/**
 * Wrapper handle unhnandled promise rejection from async express routes.
 * By default express error middleware won't handle promise rejection.
 * With async wrapper, we can handle error and return correct status code
 * depends on exception type.
 * @param fn express api route
 */
export declare function asyncWrapper<TRequest extends express.Request = express.Request, TResponse extends express.Response = express.Response>(fn: (req: TRequest, res: TResponse, next: express.NextFunction) => Promise<unknown>): (req: express.Request, res: express.Response, next: express.NextFunction) => void;
