"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.asyncWrapper = void 0;
/**
 * Wrapper handle unhnandled promise rejection from async express routes.
 * By default express error middleware won't handle promise rejection.
 * With async wrapper, we can handle error and return correct status code
 * depends on exception type.
 * @param fn express api route
 */
function asyncWrapper(fn) {
    return function (req, res, next) {
        Promise.resolve(fn(req, res, next)).catch(next);
    };
}
exports.asyncWrapper = asyncWrapper;
//# sourceMappingURL=asyncWrapper.js.map